'use strict';

/**
 * dev:黄静超
 * desc:小程序专用授权弹框
 * props:isShow,title,text
 * event:closeEvent,failEvent,successEvent
 */
var app = getApp();
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    //是否打开弹窗
    isShow: {
      type: Boolean,
      value: false
    },
    //授权框标题
    title: {
      type: String,
      value: '登录成功'
    },
    //授权框文字描述
    text: {
      type: String,
      value: '为了给你提供更好的服务，途家申请获取你的公开信息\n（微信头像、昵称等）'
    }
  },

  /**
   * 组件的初始数据
   */
  data: {},
  /**
   * 组件的方法列表
   */
  methods: {
    /**
     * 获取用户信息回调
     * @event successEvent   触发用户信息授权成功事件
     * @event failEvent      触发用户信息授权取消事件
     */
    _getUserInfo: function _getUserInfo(e) {
      var userInfo = e.detail.userInfo;
      if (userInfo) {
        app.globalUserInfo.wxUserInfo = userInfo;
        wx.setStorage({
          key: 'wxUserInfo',
          data: userInfo
        });
        this.triggerEvent('successEvent', userInfo);
      } else {
        this.triggerEvent('failEvent');
      }

      this._close();
    },

    /**
     * 关闭事件
     * @event closeEvent    触发用户信息弹框关闭事件
     */
    _close: function _close() {
      this.triggerEvent('closeEvent');
    }
  }
});