/* eslint-disable import/no-commonjs */
const fs = require('fs');
const path = require('path')
const hostPath = path.join(__dirname, './host.js')
const oldRootApi = require(hostPath);
const devModeNames = ['t1', 't2', 'fvt', 'build'];
let mode = process.argv.splice(2)[0];
let isDevMode = devModeNames.indexOf(mode) != -1;
mode = isDevMode ? mode : ''

function main() {
  if (!mode || (oldRootApi && oldRootApi.mode && oldRootApi.mode === mode)) {
    return
  }
  //根据命令行mode参数生成对应的文件           
  let data = `
  import React from '@react';
  import t1Apis from './deploy_t1;
  import t2Apis from './deploy_t2';
  import fvtApis from './deploy_fvt';
  import buildApis from './deploy_build';

  var apis = null
  function main(){
     var mode = '${mode}';
     var initDevMode = mode;
     if(mode !== 'build'){
          try{
            var m = React.api.getStorageSync('TEST_HOST')
            mode = m || mode                               
          }
          catch(err){}
     }
     apis = require('./deploy_'+mode);
     // 当前环境host模式
     apis.devMode = mode;
     // 初始环境host模式
     apis.initDevMode = initDevMode;
     return apis
  }
  main()
  export default apis;`;
  fs.writeFile(hostPath, data, (err) => {
    if (err) {
      console.log('fs.writeFile error:', err);
    }
  })
}
main();