import { Block, View, Text, Button } from '@tarojs/components'
import Taro from '@tarojs/taro'
import withWeapp from '@tarojs/with-weapp'
import './popup.scss'

const app = Taro.getApp()

@withWeapp('Component')
class _C extends Taro.Component {
  static defaultProps = {
    isShow: false,
    title: '登录成功',
    text: '为了给你提供更好的服务，途家申请获取你的公开信息\n（微信头像、昵称等）'
  }
  _observeProps = []
  state = {}
  _getUserInfo = e => {
    let userInfo = e.detail.userInfo
    if (userInfo) {
      app.globalUserInfo.wxUserInfo = userInfo
      Taro.setStorage({
        key: 'wxUserInfo',
        data: userInfo
      })
      !!this.props.onSuccessEvent && this.props.onSuccessEvent()
      // this.triggerEvent('successEvent', userInfo)
    } else {
      !!this.props.onFailEvent && this.props.onFailEvent()
      // this.triggerEvent('failEvent')
    }

    this._close()
  }
  _close = () => {
    !!this.props.onCloseEvent && this.props.onCloseEvent()
    // this.triggerEvent('closeEvent')
  }
  config = {
    component: true
  }

  render() {
    const { isShow: isShow, title: title, text: text } = this.props
    const { } = this.state

    console.log('------isShow:', isShow)

    return (
      <Block>
        {
          isShow && (
            <View className='auth-contaniner'>
              <Text className='auth-title'>{title}</Text>
              <Text className='auth-text'>{text}</Text>
              <Button
                className='auth-btn-confirm'
                hoverClass='auth-btn-hover'
                openType='getUserInfo'
                onGetuserinfo={this._getUserInfo}
              >
                允许
              </Button>
              <View className='auth-btn-cancel' onClick={this._close}>
                取消
              </View>
            </View>
          )
        }
      </Block>
    )
  }
}

export default _C
